<?php
require('./config.php');
include('./includes/header.php');
switch(SQL_SERVERTYPE){
	case 'MYSQL':
		require_once('./includes/db.mysql.php');
		break;
	case 'POSTGRESQL':
		require_once('./includes/db.postgresql.php');
		break;
}
$db = new db();
require_once('./includes/functions.php');
require_once('./includes/pureftpd.class.php');
$pureftpd = new pureftpd();
	function edit($edituser,$notice,$error){
		global $pureftpd,$user;
	if($user = $pureftpd->get_user($edituser)) {
	?>
<div id="content">
	<h2>Users - edit <span style="text-decoration:underline;"><?php echo $user->{FIELD_USER}; ?></span></h2>
	<?php if(!empty($error)) echo '<div id="error">'.$error.'</div>'; ?>
	<?php if(!empty($notice)) echo '<div id="error">'.$notice.'</div>'; ?>
	<form method="post" action="user.php?edit=<?php echo strhex($user->{FIELD_USER}); ?>">
		<fieldset style="margin:0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Common data</legend>
			<label class="leftlabel">Username:</label> <input type="text" name="User" value="<?php echo $user->{FIELD_USER}; ?>" maxlength="16" /><br/>
			<label class="leftlabel">Home Directory:</label> <input type="text" name="Dir" value="<?php echo $user->{FIELD_DIR}; ?>" maxlength="128" /><br />
			<label class="leftlabel">User ID:</label> <input type="text" name="Uid" value="<?php echo $user->{FIELD_UID}; ?>" maxlength="11" /><br />
			<label class="leftlabel">Group ID:</label> <input type="text" name="Gid" value="<?php echo $user->{FIELD_GID}; ?>" maxlength="11" /><br />
			<label class="leftlabel">Quota:</label> <input type="text" name="Quota" value="<?php echo $user->{FIELD_QUOTA}; ?>" maxlength="10" /><br />
		</fieldset>
		<fieldset style="margin:0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Set new password</legend>
			<label class="leftlabel">New password:</label> <input type="password" name="new_password" /><br/>
			<label class="leftlabel">Repeat password:</label> <input type="password" name="new_password_repeat" /><br />
		</fieldset>
		<fieldset style="margin: 0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Save user</legend>
			<input type="checkbox" name="delete_user" id="delete_user" /><label for="delete_user" style="font-size:0.9em;">Delete user on saving</label><br />
			<input type="reset" value="Reset" style="float:left;" />
			<input type="submit" name="submit_save" value="Save" style="float:right;" />
		</fieldset>
	</form>
</div>
	<?php
		}
	}
	function start($notice = FALSE){
		global $pureftpd, $users;
		$users = $pureftpd->get_user_list();
		?>
		<div id="content">
			<h2>Users</h2>
			<?php if($notice != FALSE) echo '<div class="notice">'.$notice.'</div>'; ?>
			<div id="ftp-user">
				<table summary="Pure-FTPd users">
					<tr>
						<th>User</th>
						<th>UID</th>
						<th>GID</th>
						<th>Quota</th>
						<th>Home Directory</th>
					</tr>
				<?php
				foreach($users AS $user){
					echo '			<tr>'."\n";
					echo '				<td><a href="user.php?edit='.strhex($user->{FIELD_USER}).'">'.$user->{FIELD_USER}.'</a></td>'."\n";
					echo '				<td>'.$user->{FIELD_UID}.'</td>'."\n";
					echo '				<td>'.$user->{FIELD_GID}.'</td>'."\n";
					echo '				<td>'.$user->{FIELD_QUOTA}.'</td>'."\n";
					echo '				<td>'.$user->{FIELD_DIR}.'</td>'."\n";
					echo "			</tr>"."\n";
				}
				?>
				</table>
			</div>
			<script type="text/javascript">
				function setPath(){
					document.getElementById("Dir").value = '<?php echo DEFAULT_DIR; ?>' + document.getElementById("User").value;
				}
			</script>
				<form method="post" action="user.php" id="createUser">
				<fieldset style="margin:1em;border:1px solid silver;font-size:0.9em;">
					<legend>Create new user</legend>
					<label class="leftlabel">Username:</label> <input type="text" name="User" id="User" onkeypress="javascript:setPath();" onchange="javascript:setPath();" /><br />
					<label class="leftlabel">UID:</label>	<input type="text" name="Uid" value="<?php echo DEFAULT_UID; ?>" /><br />
					<label class="leftlabel">GID:</label> <input type="text" name="Gid" value="<?php echo DEFAULT_GID; ?>" /><br />
					<label class="leftlabel">Quota:</label> <input type="text" name="Quota" value="<?php echo DEFAULT_QUOTA; ?>" /><br />
					<label class="leftlabel">Homedir:</label> <input type="text" name="Dir" id="Dir" value="<?php echo DEFAULT_DIR; ?>" /><br />
					<label class="leftlabel">Password:</label> <input type="password" name="Password" />
					<label class="leftlabel2">Repeat Password:</label> <input type="password" name="Password2" /><br />
					<input type="reset" value="Reset Form" style="float:left;"  /> <input type="submit" name="submit_add" value="Create User" style="float:right;" /><br />
				</fieldset>
			</form>
		</div>
		<?php
	}
	function throw_create_error($error,$type = 'error'){
		?>
		<div id="content">
			<h2>Users - New User</h2>
			<?php
				switch ($type){
					case 'error':
						echo '<div id="error">'.$error.'</div>';
						break;
					case 'notice':
						echo '<div id="notice">'.$error.'</div>';
						break;
				}
				if($type == 'error'){
				?>
				<script type="text/javascript">
					function setPath(){
						document.getElementById("Dir").value = '<?php echo DEFAULT_DIR; ?>' + document.getElementById("User").value;
					}
				</script>
				<form method="post" action="user.php" id="createUser">
				<fieldset style="margin:1em;border:1px solid silver;font-size:0.9em;">
					<legend>Create new user</legend>
					<label class="leftlabel">Username:</label> <input type="text" name="User" id="User" onkeypress="javascript:setPath();" onchange="javascript:setPath();" value="<?php echo $_POST['User']; ?>" /><br />
					<label class="leftlabel">UID:</label>	<input type="text" name="Uid" value="<?php echo $_POST['Uid']; ?>" /><br />
					<label class="leftlabel">GID:</label> <input type="text" name="Gid" value="<?php echo $_POST['Gid']; ?>" /><br />
					<label class="leftlabel">Quota:</label> <input type="text" name="Quota" value="<?php echo $_POST['Quota']; ?>" /><br />
					<label class="leftlabel">Homedir:</label> <input type="text" name="Dir" id="Dir" value="<?php echo $_POST['Dir']; ?>" /><br />
					<label class="leftlabel">Password:</label> <input type="password" name="Password" value="<?php echo $_POST['Password']; ?>" />
					<label class="leftlabel2">Repeat Password:</label> <input type="password" name="Password2" value="<?php echo $_POST['Password2']; ?>" /><br />
					<input type="reset" value="Reset Form" style="float:left;"  /> <input type="submit" name="submit_add" value="Create User" style="float:right;" /><br />
				</fieldset>
			</form>
			<?php } ?>
		<a class="backlink" href="user.php">Back to Users page</a>
	</div>
	<?php
	}
if(isset($_POST['submit_save'])){
	$error = '';
	$notice = '';
	if($user = $pureftpd->get_user(hexstr($_GET['edit']))){
		if(isset($_POST['delete_user']) && $_POST['delete_user'] == 'TRUE'){
			$pureftpd->delete_user($user->{FIELD_USER});
		} else {
			/** change password ? */
			if(isset($_POST['new_password']) && !empty($_POST['new_password'])){
				if($_POST['new_password'] == $_POST['new_password_repeat']){
					if($pureftpd->change_user(FIELD_PASSWORD,$_POST['new_password'],$user->{FIELD_USER}))
						$notice .= 'Password changed successfully <br />';
					else
						$error .= 'An error occured on trying to change the password!<br />';
				} else {
					$error .= 'New Passwords do not match! <br />';
				}
			}
			/** change home directory */
			if(isset($_POST['Dir']) && $_POST['Dir'] != $user->{FIELD_DIR}){
				if($pureftpd->change_user(FIELD_DIR,$_POST['Dir'],$user->{FIELD_USER}))
					$notice .= 'Home directory changed successfully! <br />';
				else
					$error .= 'An error occured on trying to change the home directory! <br />';
			}
			/** change uid */
			if(isset($_POST['Uid']) && $_POST['Uid'] != $user->{FIELD_UID}){
				if($pureftpd->change_user(FIELD_UID,$_POST['Uid'],$user->{FIELD_USER}))
					$notice .= 'User ID changed successfully. <br />';
				else
					$error .= 'An error occured on trying to change the user ID! <br />';
			}
			/** change gid */
			if(isset($_POST['Gid']) && $_POST['Gid'] != $user->{FIELD_GID}){
				if($pureftpd->change_user(FIELD_GID,$_POST['Gid'],$user->{FIELD_USER}))
					$notice .= 'Group ID changed successfully. <br />';
				else
					$error .= 'An error occured on trying to change the Group ID! <br />';
			}
			/** change quota */
			if(isset($_POST['Quota']) && $_POST['Quota'] != $user->{FIELD_QUOTA}){
				if($pureftpd->change_user(FIELD_QUOTA,$_POST['Quota'],$user->{FIELD_USER}))
					$notice .= 'Quota changed successfully. <br />';
				else
					$error .= 'An error occured on trying to change the quota! <br />';
			}
			/** change username ? */
			if($user->{FIELD_USER} != $_POST['User']){
				if(!$pureftpd->check_user_existance($_POST['User'])){
					if($pureftpd->change_user(FIELD_USER,$_POST['User'],$user->{FIELD_USER}))
						$notice .= 'Username changed successfully. <br />';
					else
						$error .= 'An error occured on trying to change the username! <br />';
				} else {
					$error .= 'The username you want to change this user to already exists! <br />';
				}
			}
			/** Done all changes, return to main screen and display notices */
			if(empty($error)){
				start($notice);
			} else {
				edit($user->{FIELD_USER},$notice,$error);
			}
		}
	} else {
		?>
<div id="content">
	<h2>Users - edit</h2>
	<div id="error">The User <?php echo hexstr($_GET['edit']); ?> could not be found or is invalid.<br /><a href="user.php">Back...</a></div>
</div>
		<?php
	}
} elseif(isset($_POST['submit_add'])){
	if($pureftpd->check_user_existance($_POST['User'])){
		throw_create_error('A User with this username already exists! Choose another name.');
	} else {
		if($_POST['Password'] != $_POST['Password2']){
			throw_create_error('The Passwords do not match! Set the same password both for the Fields <em>Password</em> and <em>Repeat Password</em>!');
		} else {
			if($pureftpd->add_user($_POST['User'],$_POST['Password'],$_POST['Uid'],$_POST['Gid'],$_POST['Quota'],$_POST['Dir'])){
				throw_create_error('User successfully created.<br /><a href="user.php">Back to Users page</a>','notice');
			} else {
				throw_create_error('User was not created! Check your input and try again!','error');
			}
		}
	}
} elseif(isset($_GET['edit'])){
	if($user = $pureftpd->get_user(hexstr($_GET['edit']))){
	?>
<div id="content">
	<h2>Users - edit <span style="text-decoration:underline;"><?php echo $user->{FIELD_USER}; ?></span></h2>
	<form method="post" action="user.php?edit=<?php echo strhex($user->{FIELD_USER}); ?>">
		<fieldset style="margin:0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Common data</legend>
			<label class="leftlabel">Username:</label> <input type="text" name="User" value="<?php echo $user->{FIELD_USER}; ?>" maxlength="16" /><br/>
			<label class="leftlabel">Home Directory:</label> <input type="text" name="Dir" value="<?php echo $user->{FIELD_DIR}; ?>" maxlength="128" /><br />
			<label class="leftlabel">User ID:</label> <input type="text" name="Uid" value="<?php echo $user->{FIELD_UID}; ?>" maxlength="11" /><br />
			<label class="leftlabel">Group ID:</label> <input type="text" name="Gid" value="<?php echo $user->{FIELD_GID}; ?>" maxlength="11" /><br />
			<label class="leftlabel">Quota:</label> <input type="text" name="Quota" value="<?php echo $user->{FIELD_QUOTA}; ?>" maxlength="10" /><br />
		</fieldset>
		<fieldset style="margin:0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Set new password</legend>
			<label class="leftlabel">New password:</label> <input type="password" name="new_password" /><br/>
			<label class="leftlabel">Repeat password:</label> <input type="password" name="new_password_repeat" /><br />
		</fieldset>
		<fieldset style="margin: 0 1em 0 1em;">
			<legend style="font-size:0.9em;font-weight:bold;">Save user</legend>
			<input type="checkbox" name="delete_user" id="delete_user" /><label for="delete_user" style="font-size:0.9em;">Delete user on saving</label><br />
			<input type="reset" value="Reset" style="float:left;" />
			<input type="submit" name="submit_save" value="Save" style="float:right;" />
		</fieldset>
	</form>
</div>
	<?php
	} else {
		?>
<div id="content">
	<h2>Users - edit</h2>
	<div id="error">The User <?php echo hexstr($_GET['edit']); ?> could not be found or is invalid.<br /><a href="user.php">Back...</a></div>
</div>
		<?php
	}

} else {
	start();
/*
	$users = $pureftpd->get_user_list();
?>
<div id="content">
	<h2>Users</h2>
	<div id="ftp-user">
		<table summary="Pure-FTPd users">
			<tr>
				<th>User</th>
				<th>UID</th>
				<th>GID</th>
				<th>Quota</th>
				<th>Home Directory</th>
			</tr>
<?php
			foreach($users AS $user){
				echo '			<tr>'."\n";
				echo '				<td><a href="user.php?edit='.strhex($user->{FIELD_USER}).'">'.$user->{FIELD_USER}.'</a></td>'."\n";
				echo '				<td>'.$user->{FIELD_UID}.'</td>'."\n";
				echo '				<td>'.$user->{FIELD_GID}.'</td>'."\n";
				echo '				<td>'.$user->{FIELD_QUOTA}.'</td>'."\n";
				echo '				<td>'.$user->{FIELD_DIR}.'</td>'."\n";
				echo "			</tr>"."\n";
			}
		?>
		</table>
	</div>
	<script type="text/javascript">
		function setPath(){
			document.getElementById("Dir").value = '<?php echo DEFAULT_DIR; ?>' + document.getElementById("User").value;
		}
	</script>
		<form method="post" action="user.php" id="createUser">
		<fieldset style="margin:1em;border:1px solid silver;font-size:0.9em;">
			<legend>Create new user</legend>
			<label class="leftlabel">Username:</label> <input type="text" name="User" id="User" onkeypress="javascript:setPath();" onchange="javascript:setPath();" /><br />
			<label class="leftlabel">UID:</label>	<input type="text" name="Uid" value="<?php echo DEFAULT_UID; ?>" /><br />
			<label class="leftlabel">GID:</label> <input type="text" name="Gid" value="<?php echo DEFAULT_GID; ?>" /><br />
			<label class="leftlabel">Quota:</label> <input type="text" name="Quota" value="<?php echo DEFAULT_QUOTA; ?>" /><br />
			<label class="leftlabel">Homedir:</label> <input type="text" name="Dir" id="Dir" value="<?php echo DEFAULT_DIR; ?>" /><br />
			<label class="leftlabel">Password:</label> <input type="password" name="Password" />
			<label class="leftlabel2">Repeat Password:</label> <input type="password" name="Password2" /><br />
			<input type="reset" value="Reset Form" style="float:left;"  /> <input type="submit" name="submit_add" value="Create User" style="float:right;" /><br />
		</fieldset>
	</form>
</div>
<?php
*/
}
include('./includes/footer.php');
?>